
/*
**  This file forms part of the GOBLIN C++ Class Library.
**
**  Written by Christian Fremuth-Paeger, January 2002.
**  
**  Copying, compiling, distribution and modification
**  of this source code is permitted only in accordance
**  with the GOBLIN general licence information.
*/             



#include "treeView.h"

goblinTreeView::goblinTreeView(TNode n,goblinController &thisContext) throw() :
    goblinDataObject(thisContext),
    abstractMixedGraph(n,TArc(0)),
    diGraph(n,TOption(0),thisContext)
{
    LogEntry(LOG_MEM,"Generating tree view...");
    InitColours();
}


goblinTreeView::~goblinTreeView() throw()
{
    LogEntry(LOG_MEM,"...tree view disallocated");
}


void goblinTreeView::ConfigDisplay(goblinController &CFG) throw()
{
    CFG.predecessors = 0;
    CFG.nodeLabels = 2;
    CFG.arcLabels = 0;
    CFG.arcLabels2 = 0;
    CFG.nodeColours = 2;
    CFG.subgraph = 2;
    CFG.legenda = 0;
}

