#include <goblin.h>
#include "lpSolve.h"


void myLogEventHandler(msgType msg,TModule mod,THandle OH,char *logText)
{
    CT -> PlainLogEventHandler(msg,mod,OH,logText);
}


int main(int ParamCount,char *ParamStr[])
{           
    goblinDefaultContext.logStream       = new ofstream("dump");
    goblinDefaultContext.logEventHandler = &LogEventHandler;
    
    goblinLPSolver A(3,3,8,MINIMIZE);
    
    A.Resize(23,34,45);
    A.Resize(34,45,56);
    A.Resize(20,30,40);
    A.Strip();
    
    A.AddVar(0,2,-2);
    A.AddVar(0,2,-3);
    A.AddVar(0,3,-4);
    
    A.AddRestr(0,4);
    A.AddRestr(0,10);
    A.AddRestr(0,11);

    A.SetCoeff(0,0,1);
    A.SetCoeff(0,1,2);
    A.SetCoeff(0,2,0);
    A.SetCoeff(1,0,1);
    A.SetCoeff(1,1,0);
    A.SetCoeff(1,2,1);
    A.SetCoeff(2,0,0);
    A.SetCoeff(2,1,1);
    A.SetCoeff(2,2,1);
    
    A.Write("test.lp",LP_FORMAT);

    A.EvaluateBasis();
    A.Pivot(0,1,BASIC_UB);
    A.EvaluateBasis();
    
    TIndex i = 0;
    for (;i<3;i++) cout << "x[" << i << "] = " << A.X(i) << endl;
    for (i=0;i<4;i++) cout << "y+[" << i << "] = " << A.Y(i,BASIC_UB) << endl;
    for (i=0;i<4;i++) cout << "y-[" << i << "] = " << A.Y(i,BASIC_LB) << endl;
    
    delete goblinDefaultContext.logStream;
    goblinDefaultContext.logStream = &clog;

    return 0; 
}
