

-----------------------------------------------------------------------------
                          Scheduled for Release 2.7
-----------------------------------------------------------------------------


Bugfix    : Memory leak when working with threads
Scope     : Library/Shell

Milestone        : Composition of linear programs
Scope            : Handling
Estimated Effort : 3-4 weeks
Dependencies     : None
Comments         : (1) Polar / Recession cones
                 : (2) Compose line graph from LP
                 : (3) Deletion of rows/variables

Milestone        : Dakin method
Scope            : Algorithms
Estimated Effort : 2-3 weeks
Dependencies     : None
Comments         : Basic branch and bound for general integer programming

Milestone        : Gomory Cutting Planes
Scope            : Algorithms
Estimated Effort : ???
Dependencies     : None
Comments         : General separation scheme

Milestone        : Improved Spring Embedding
Scope            : Algorithms
Estimated Effort : 1-2 weeks
Dependencies     : None
Comments         : Going to 3rd dimension, local search, adding center of gravity

Milestone        : Export of logfile
Scope            : GUI
Estimated Effort : 1 week
Dependencies     : None
Comments         : Export logfile from GOBLET messenger without header info

Milestone        : Doxygen comments
Scope            : Documentation
Estimated Effort : 2 weeks
Dependencies     : Requires a strategy
Comments         : Support for automated documentation

Milestone        : (File) support for problem comments
Scope            : Documentation
Estimated Effort : 1 week
Dependencies     : None

Milestone        : Browsing facility for duality gaps
Scope            : GUI
Estimated Effort : 2 weeks
Dependencies     : None

Milestone        : Wallpapers
Scope            : GUI
Estimated Effort : 2 weeks
Dependencies     : None
Comments         : (1) Dialog for file selection
                 : (2) Relative path mechanism
                 : (3) Export to xFig format
                 : (4) Editor sometimes draws object behind wallpaper

Milestone        : 
Scope            : Redesign
Estimated Effort : 1 week
Dependencies     : None
Comments         : Make MinTree as well as Arborescence method available for
                   mixed graphs

Milestone        : GLPK plugin
Scope            : Interfaces
Estimated Effort : 2 weeks
Dependencies     : None
Comments         : (1) Display of tableau information
                 : (2) Make sparse column definitions abstract. Apply to
                 :     MPS loader and to min-cost flow.
                 : (3) Extend methLP to interior point method (GUI also)

Milestone        : Revision of the DMP planarity code
Scope            : Library
Estimated Effort : 1 weeks
Dependencies     : None
Comments         : Segments should require O(m) storage


-----------------------------------------------------------------------------
                            Unscheduled Projects
-----------------------------------------------------------------------------


Milestone        : Module for automated testing
Scope            : GUI
Estimated Effort : 3 weeks
Dependencies     : None
Comments         : 

Milestone        : Documentation of file formats
Scope            : Documentation
Estimated Effort : 3 weeks
Dependencies     : None
Comments         : Describe all supported file formats

Milestone        : MKM method for maximum flows
Scope            : Algorithms
Estimated Effort : 2 weeks
Dependencies     : None
Comments         : Reuse Dinic code

Milestone        : Revision of graph data structures
Scope            : Redesign
Estimated Effort : 1 month
Dependencies     : Index data structure, change of file format -> Release 3
Comments         : Explicit arc colours and free labellings

Milestone        : Editing of colour tables
Scope            : GUI
Estimated Effort : 1-2 weeks
Dependencies     : None
Comments         : 

Milestone        : Global object handles
Scope            : Redesign
Estimated Effort : 1 week
Dependencies     : None
Comments         : Compute object indices from hash table. Do not reuse indices

Milestone        : Improved starting heuristics for NP-hard problems
Scope            : Algorithms
Estimated Effort : 6 weeks
Dependencies     : Requires literature
Comments         : Especially for max-cut and independent set

Milestone        : Progress bar
Scope            : GUI
Estimated Effort : 1 week
Dependencies     : None
Comments         : 

Milestone        : Branch and cut scheme
Scope            : Algorithms
Estimated Effort : 6-8 weeks
Dependencies     : Dakin, Gomory
Comments         : Sophisticated branch & cut including restriction pools

Milestone        : Problems with linear side constraints
Scope            : Redesign
Estimated Effort : 3-4 weeks
Dependencies     : None
Comments         : General subgradient optimization scheme

Milestone        : Minimum cut networks
Scope            : Algorithms
Estimated Effort : 3 weeks
Dependencies     : None
Comments         : Compose minimum cut network from dense undirected graph

Milestone        : Post-Optimization for matching code
Scope            : Algorithms, redesign
Estimated Effort : ???
Dependencies     : None
Comments         : Optimization on sparse graphs

Milestone        : Separation of subtours
Scope            : Algorithms
Estimated Effort : 1-2 weeks
Dependencies     : Branch and cut scheme
Comments         : Reuse min-cut code

Milestone        : General local search scheme
Scope            : Algorithms, redesign
Estimated Effort : ???
Dependencies     : None
Comments         : Simulated annealing?

Milestone        : Steiner tree branch and bound
Scope            : Algorithms
Estimated Effort : 3 weeks
Dependencies     : None

Milestone        : Tracing interaction
Scope            : GUI, Redesign
Estimated Effort : 2 weeks
Dependencies     : None
Comments         : 

Milestone        : Revised graph composition
Scope            : Library, graph handling
Estimated Effort : 1-2 weeks
Dependencies     : None
Comments         : (1) Backtransformation of nodes and arcs
                   (2) Simple graphs choose the arc with minimum cost

Milestone        : Redesign of tracepoint filter
Scope            : Tracing
Estimated Effort : 1 week
Dependencies     : None
Comments         : Restrict trace points by a maximum module nesting level

Milestone        : Advanced planarity features
Scope            : Library
Estimated Effort : 6 week
Dependencies     : Explicit combinatorial embedding
Comments         : (1) Geometric embedding
                 : (2) Combinatorial embedding for non-planar graphs


-----------------------------------------------------------------------------
                            General redesign goals
-----------------------------------------------------------------------------

(1) Mark more methods as private
(2) Avoid global symbols
(3) Implement ownership types
(4) Doxygen comments
(5) const parameters
(6) Type TDim instead of char for node coordinates
(7) Type TLowerUpper instead of char for branch directions
(8) More explicit file names
(9) Avoid static variables



-----------------------------------------------------------------------------
                            
-----------------------------------------------------------------------------

Milestone        : 
Scope            : 
Estimated Effort : 
Dependencies     : 
Comments         : 
